#include <stdio.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>
#include <sys/stat.h>
#include <X11/Xlib.h>

#include "pind.h"


int total, elaps;
Bool live=False, prev=False;

void mysigterm();
void putLock(Bool);



void Out(void)
{
	exit(1);
}

Bool pppActive(void)
{
	int p=0;
	Bool ret=False;
	FILE *filep;

	filep=fopen("/proc/net/route", "rt");

	while(!feof(filep))	{
		if(tolower(fgetc(filep))=='p')
			p++;
		else
			p=0;
		if(p==3)	{
			fclose(filep);
			return True;
			}
		}

	fclose(filep);
	return False;
}

/* ----------------------------------------------------------------------*/

void putLock(Bool lck)
{
	FILE *filep;

	if(lck)	{
		filep=fopen(LOCK_FILE, "wb");
		putw(1, filep);
		fclose(filep);
		}
	else
		remove(LOCK_FILE);
}

void saveTotal(void)
{
	FILE *filep;

	filep=fopen(SUM_FILE, "wb");
	putw(total, filep);

	fclose(filep);
}

void saveStatus(void)
{
	FILE *filep;

	putLock(True);
	filep=fopen(STATUS_FILE, "wb");

	putw((int)live, filep);
	putw((int)prev, filep);
	putw(elaps, filep);
	putw(total, filep);

	fclose(filep);
	putLock(False);

	saveTotal();
}

void loadTotal(void)
{
	FILE *filep;

	if(!(filep=fopen(SUM_FILE, "rb")))	total=0;
	else	total=getw(filep);

	fclose(filep);
}


void mysigterm()
{
	if(live)
		total+=elaps;

	saveTotal();
	Out();
}

void daemon_init(void)
{
	int pid;

	if((pid=fork())<0)	{
		printf("Error becoming a daemon....");
		exit(0);
		}

	if(pid>0)
		exit(1);

	chdir("/");
	setsid();
	umask(0);
}

void main(int argc, char *argv[])
{
    char str[20];
	Bool key;

	int idle_time=5;
	time_t time_start, total_start;

	daemon_init();

	signal(SIGTERM,mysigterm);
	signal(SIGHUP,mysigterm);
	signal(SIGINT,mysigterm);

	loadTotal();

	while(1)	{
		key=pppActive();
		if(key)	{
			if(!live)	{
				total_start=total;
				live=True;
				idle_time=3;
				time_start=time(NULL);
				}

			elaps=time(NULL)-time_start;
			total=total_start+elaps;
			saveStatus();
			}
		else	{
			if(live)	{
				idle_time=6;
				prev=True;
				live=False;
				}
			saveStatus();
			}

		sleep(idle_time);
		};

	Out();
}
